package com.engine.htsc.itcssx.web;

import com.alibaba.fastjson.JSON;
import com.engine.common.util.ServiceUtil;
import com.engine.htsc.itcssx.service.ITTestOnlineService;
import com.engine.htsc.seal.service.SealApplicationService;
import weaver.general.BaseBean;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

public class ITTestOnlineAction {

    ITTestOnlineService getService(){
        return ServiceUtil.getService(ITTestOnlineService.class);
    }

    @POST
    @Path("/getSignDept")
    @Produces({MediaType.TEXT_PLAIN})
    public String getLeader(@Context HttpServletRequest request, @Context HttpServletResponse response){
        BaseBean bs = new BaseBean();
        Map<String, Object> apidatas = new HashMap<String, Object>();
        bs.writeLog("----ITTestOnlineAction-----");
        try{
            String requestid = request.getParameter("requestid");

            ITTestOnlineService service = getService();
            apidatas = service.getSignDept(requestid);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }

        return JSON.toJSONString(apidatas);
    }

    @POST
    @Path("/getDefaultNotice")
    @Produces({MediaType.TEXT_PLAIN})
    public String getDefaultNotice(@Context HttpServletRequest request, @Context HttpServletResponse response){
        BaseBean bs = new BaseBean();
        Map<String, Object> apidatas = new HashMap<String, Object>();
        bs.writeLog("----ITTestOnlineAction-----");
        try{
            String deptid = request.getParameter("deptid");

            ITTestOnlineService service = getService();
            apidatas = service.getDefaultNotice(deptid);
        }catch (Exception e) {
            e.printStackTrace();
            apidatas.put("api_status", false);
            apidatas.put("api_errormsg", "catch exception : " + e.getMessage());
        }

        return JSON.toJSONString(apidatas);
    }

}
