package com.engine.htsc.payment.enums;

public class Pay {

  public enum Branch {
    PAY("fzjgtyfk", "fzjgtyfk_bj"),
    REI("fzjgtybx", "fzjgtybx_bj"),
    TRIP_PAY("fzjgsljsfk", "fzjgsljsfk_bj"),
    TRIP_REI("fzjgclbx", "fzjgclbx_bj");
    private final String wfUnNumber;
    private final String endUnNumber;

    Branch(String wfUnNumber, String endUnNumber) {
      this.wfUnNumber = wfUnNumber;
      this.endUnNumber = endUnNumber;
    }

    public String getWfUnNumber() {
      return wfUnNumber;
    }

    public String getEndUnNumber() {
      return endUnNumber;
    }
  }

  public enum Head {
    PAY("zbtyfk", "zbtyfk_bj"),
    PAY_IT("zbitfk", "zbitfk_bj"),
    PAY_GH("zbghfk", "zbghfk_bj"),
    PAY_SL("sljsfk", "sljsfk_bj"),
    TRIP_REI("zbclbx", "zbclbx_bj");
    private final String wfUnNumber;
    private final String endUnNumber;

    Head(String wfUnNumber, String endUnNumber) {
      this.wfUnNumber = wfUnNumber;
      this.endUnNumber = endUnNumber;
    }

    public String getWfUnNumber() {
      return wfUnNumber;
    }

    public String getEndUnNumber() {
      return endUnNumber;
    }
  }

  /**
   * 香港通用付款；xgtyfk_bj
   * 香港通用报销；xgtybx_bj
   * 联合通用报销；lhtybx_bj
   * 联合出差申请；ccsq_bj
   * 联合差旅报销；clbx_bj
   * 资管通用报销；zgtybx_bj
   * 资管差旅报销；zgclbx_bj
   * 紫金通用报销；zjtybx_bj
   * 紫金差旅报销；zjclbx_bj
   * 财务调整；cwtz_bj
   * 联合财务调整；lhcwtz_bj
   * 财务考核调整；cwkhtz_bj
   * 托收业务流程；fyft_bj
   * 资金业务付款；zjywfk_bj
   * 内部资金调拨；zbzjnbdb_bj
   * 预收款费用确认流程；zbyfkfyqr_bj
   * 采购商城费用确认流程；cgscfyqr_bj
   * 采购商城结算付款流程；cgscjsfk_bj
   */
  public enum Sub {
    XG_TY_PAY("xgtyfk", "xgtyfk_bj"),
    XG_TY_REI("xgtybx", "xgtybx_bj"),
    LH_TY_REI("lhtybx", "lhtybx_bj"),
    LH_CL_SQ("ccsq", "ccsq_bj"),
    LH_CL_REI("clbx", "ccsq_bj"),
    ZG_TY_REI("zgtybx", "zgtybx_bj"),
    ZG_CL_REI("zgclbx", "zgclbx_bj"),
    CW_TZ("cwtz", "cwtz_bj"),
    LH_CW_TZ("lhcwtz", "lhcwtz_bj"),
    CW_KH_TZ("cwkhtz", "cwkhtz_bj"),
    TS_YW_PAY("fyft", "fyft_bj"),
    ZJ_YW_PAY("zjywfk", "zjywfk_bj"),
    ZJ_DB("zbzjnbdb", "zbzjnbdb_bj"),
    PRE_PAY("zbyfkfyqr", "zbyfkfyqr_bj"),
    MALL_PRE_PAY("cgscfyqr", "cgscfyqr_bj"),
    MALL_PAY("cgscjsfk", "cgscjsfk_bj");
    private final String wfUnNumber;
    private final String endUnNumber;

    Sub(String wfUnNumber, String endUnNumber) {
      this.wfUnNumber = wfUnNumber;
      this.endUnNumber = endUnNumber;
    }

    public String getWfUnNumber() {
      return wfUnNumber;
    }

    public String getEndUnNumber() {
      return endUnNumber;
    }
  }

}
