package com.engine.htsc.payment.log;

/**
 * 日志接口
 */
public interface PaymentLogger {

    public boolean isDebugEnabled();

    /**
     * 打印debug日志
     *
     * @param message 消息
     */
    public void debug(Object message);

    /**
     * 打印debug日志
     *
     * @param message   消息
     * @param exception 异常
     */
    public void debug(Object message, Throwable exception);

    public boolean isInfoEnabled();

    /**
     * 打印info日志
     *
     * @param message 消息
     */
    public void info(Object message);


    /**
     * 打印info日志
     *
     * @param message   消息
     * @param exception 异常
     */
    public void info(Object message, Throwable exception);

    /**
     * 打印warn日志
     *
     * @param message 消息
     */
    public void warn(Object message);

    /**
     * 打印warn日志
     *
     * @param message   消息
     * @param exception 异常
     */
    public void warn(Object message, Throwable exception);

    /**
     * 打印error日志
     *
     * @param message
     */
    public void error(Object message);

    /**
     * 打印error日志
     *
     * @param message   消息
     * @param exception 异常
     */
    public void error(Object message, Throwable exception);

    public String getClassname();

    public void setClassname(String classname);

    /**
     * 初始化
     *
     * @param name logger名称
     */
    public void init(String name);


}
