package com.engine.htsc.payment.pojo;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * author: k1810012
 * 更新合同信息实体类
 */
public class OaPaymentBizRequest implements Serializable {

	private static final long serialVersionUID = -2750755799711478295L;

	/**
	 * 付款流程访问url
	 */
	private String oaPayUrl;
	/**
	 * 付款流程编号
	 */
	private String oaCode;
	/**
	 * 合同编号
	 */
	private String ctrctCode;
	/**
	 * 付款金额
	 */
	private String paymentMoney;
	/**
	 * 付款日期
	 */
	private String paymentDate;
	/**
	 * 合同流程编号
	 */
	private String processCode;

	private String sysCode;

	private String moduleCode;

	public OaPaymentBizRequest() {
	}

	public OaPaymentBizRequest(String oaPayUrl, String oaCode, String ctrctCode, String paymentMoney, String paymentDate, String processCode, String sysCode, String moduleCode) {
		this.oaPayUrl = oaPayUrl;
		this.oaCode = oaCode;
		this.ctrctCode = ctrctCode;
		this.paymentMoney = paymentMoney;
		this.paymentDate = paymentDate;
		this.processCode = processCode;
		this.sysCode = sysCode;
		this.moduleCode = moduleCode;
	}

	public String getOaPayUrl() {
		return oaPayUrl;
	}

	public void setOaPayUrl(String oaPayUrl) {
		this.oaPayUrl = oaPayUrl;
	}

	public String getOaCode() {
		return oaCode;
	}

	public void setOaCode(String oaCode) {
		this.oaCode = oaCode;
	}

	public String getCtrctCode() {
		return ctrctCode;
	}

	public void setCtrctCode(String ctrctCode) {
		this.ctrctCode = ctrctCode;
	}

	public String getPaymentMoney() {
		return paymentMoney;
	}

	public void setPaymentMoney(String paymentMoney) {
		this.paymentMoney = paymentMoney;
	}

	public String getPaymentDate() {
		return paymentDate;
	}

	public void setPaymentDate(String paymentDate) {
		this.paymentDate = paymentDate;
	}

	public String getProcessCode() {
		return processCode;
	}

	public void setProcessCode(String processCode) {
		this.processCode = processCode;
	}

	public String getSysCode() {
		return sysCode;
	}

	public void setSysCode(String sysCode) {
		this.sysCode = sysCode;
	}

	public String getModuleCode() {
		return moduleCode;
	}

	public void setModuleCode(String moduleCode) {
		this.moduleCode = moduleCode;
	}

	@Override
	public String toString() {
		return "OaPaymentBizRequest{" +
				"oaPayUrl='" + oaPayUrl + '\'' +
				", oaCode='" + oaCode + '\'' +
				", ctrctCode='" + ctrctCode + '\'' +
				", paymentMoney='" + paymentMoney + '\'' +
				", paymentDate='" + paymentDate + '\'' +
				", processCode='" + processCode + '\'' +
				", sysCode='" + sysCode + '\'' +
				", moduleCode='" + moduleCode + '\'' +
				'}';
	}

}
